/* -*-C++-*- */
#ifndef QUERYH
#define QUERYH

#include <string.h>
//#include "utils.h"

class SubQuery{
public:
  SubQuery(char *msg, char *defstr=0){
    querystring = new char[strlen(msg)+1];
    strcpy(querystring,msg);
    if (defstr) {
      isdef = true;
      strcpy (defaultstring, defstr);
    }
    else 
      isdef = false;
  }
  virtual ~SubQuery(){
    delete[] querystring;
  }

  virtual bool getfrombuf()=0;      // The text based functions
  virtual void ask(){
    cout << querystring;
    if (isdef)
      cout << " (" << defaultstring << ")";
    cout << ": " << flush;
  }

  virtual void get(){
    if ((isdef) && (buffer[strspn(buffer, " \t")]== '-')) {
      char tempbuf[300];
      strcat (strcpy (tempbuf, defaultstring), strchr(buffer, '-')+1);
      strcpy (buffer, tempbuf);
    }
    while (!getfrombuf()){
      ask();
      cin.getline(buffer,299);
      if ((isdef) && (buffer[0]==0))
	strcpy (buffer, defaultstring);
    }
  }
  //  virtual void addtowindow()=0;     // The window based functions
  //  virtual bool checkwindowval()=0;


protected:
  static char buffer[300];
  char *querystring;
  char defaultstring[100];
  bool isdef;

private:
  SubQuery();
};

class StrQuery: public SubQuery{
public:
  StrQuery(char *msg, char *resp, char *defstr= 0, int length=0)
          : SubQuery(msg, defstr){
    responsestring=0;
    responsestring=resp;
    responselength= length;
  }
  ~StrQuery(){
    //    delete[] responsestring;
  }
  
  char *val();

  bool getfrombuf();
  
  //  void addtowindow();
  //  bool checkwindowval();

private: 
  char *responsestring;
  int responselength;
};

class DblQuery: public SubQuery{
public:
  DblQuery(char *msg, char *defstr=0) : SubQuery(msg, defstr){
    response=0;
  }
  ~DblQuery(){}
  
  double val(){return response;};

  bool getfrombuf();
  
  //  void addtowindow();
  //  bool checkwindowval();

private: 
  double response;
};

class CharQuery: public SubQuery{
public:
  CharQuery(char *msg, char *defstr=0) : SubQuery(msg, defstr){
    response=0;
  }
  ~CharQuery(){}
  
  char val(){return response;};

  bool getfrombuf();
  //  void get();
  //  void addtowindow();
  //  bool checkwindowval();

private: 
  char response;
};


class IntQuery: public SubQuery{
public:
  IntQuery(char *msg, char *defstr=0) : SubQuery(msg, defstr){
    response=0;
  }
  ~IntQuery(){}
  
  int val(){return response;};

  bool getfrombuf();
  //  void get();
  //  void addtowindow();
  //  bool checkwindowval();

private: 
  int response;
};



class Query {
public:
  Query(SubQuery &a){   //Ok, so it's ugly, but it's nice to use
    subq[0]=&a;
    subq[1]=0;
    subq[2]=0;
    subq[3]=0;
    subq[4]=0;
    subq[5]=0;
  }
  Query(SubQuery &a, SubQuery &b){
    subq[0]=&a;
    subq[1]=&b;
    subq[2]=0;
    subq[3]=0;
    subq[4]=0;
    subq[5]=0;
  }
  Query(SubQuery &a, SubQuery &b, SubQuery &c){
    subq[0]=&a;
    subq[1]=&b;
    subq[2]=&c;
    subq[3]=0;
    subq[4]=0;
    subq[5]=0;
  }
  Query(SubQuery &a, SubQuery &b, SubQuery &c, SubQuery &d){
    subq[0]=&a;
    subq[1]=&b;
    subq[2]=&c;
    subq[3]=&d;
    subq[4]=0;
    subq[5]=0;
  }
  Query(SubQuery &a, SubQuery &b, SubQuery &c, SubQuery &d, SubQuery &e){
    subq[0]=&a;
    subq[1]=&b;
    subq[2]=&c;
    subq[3]=&d;
    subq[4]=&e;
    subq[5]=0;
  }
  Query(SubQuery &a, SubQuery &b, SubQuery &c, SubQuery &d,
	SubQuery &e, SubQuery &f){
    subq[0]=&a;
    subq[1]=&b;
    subq[2]=&c;
    subq[3]=&d;
    subq[4]=&e;
    subq[5]=&f;
  }

  void textask(){
    for (int i=0; i<6; i++){
      if (subq[i]!=0) subq[i]->get();
      else return;
    }
  }
  
  // xask(){
    // make X window
    // SubQuery::setWindow(mywindow)
    // for (int i=0; ((i<6)&&(subq[i]!=0)); i++)
    //   subq[i]->addtowindow();
    // add an ok button -> okbuttonhit()
    // display window
    // resume x
  //  }
  
  // okbuttonhit(){
    // cycle through, checkwindowval()
    // if ok, set flag to stop
    // otherwise beep and resume x
  // }
 
private:
  SubQuery *subq[6];
};

#endif
